{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.OGRFeature.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.OGRFeature.RawType
import GDAL.OGRFeature.FFI
import GDAL.OGRFeature.Interface
import GDAL.OGRFeature.Cast
import GDAL.OGRFeature.RawType
import GDAL.OGRFeature.Cast
import GDAL.OGRFeature.Interface
import GDAL.OGRGeometry.RawType
import GDAL.OGRGeometry.Cast
import GDAL.OGRGeometry.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IOGRFeature (OGRFeature) where

instance () => IDeletable (OGRFeature) where
        delete = xform0 c_ogrfeature_delete

oGRFeature_GetFID :: () => OGRFeature -> IO CInt
oGRFeature_GetFID = xform0 c_ogrfeature_ogrfeature_getfid

oGRFeature_GetFieldCount :: () => OGRFeature -> IO CInt
oGRFeature_GetFieldCount
  = xform0 c_ogrfeature_ogrfeature_getfieldcount

oGRFeature_GetFieldAsInteger :: () => OGRFeature -> CInt -> IO CInt
oGRFeature_GetFieldAsInteger
  = xform1 c_ogrfeature_ogrfeature_getfieldasinteger

oGRFeature_GetFieldAsInteger64 ::
                                 () => OGRFeature -> CInt -> IO CInt
oGRFeature_GetFieldAsInteger64
  = xform1 c_ogrfeature_ogrfeature_getfieldasinteger64

oGRFeature_GetFieldAsString ::
                              () => OGRFeature -> CInt -> IO CString
oGRFeature_GetFieldAsString
  = xform1 c_ogrfeature_ogrfeature_getfieldasstring

oGRFeature_GetGeometryRef :: () => OGRFeature -> IO OGRGeometry
oGRFeature_GetGeometryRef
  = xform0 c_ogrfeature_ogrfeature_getgeometryref
