{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.OGRGeometryCollection.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import GDAL.OGRGeometryCollection.RawType
import GDAL.OGRGeometryCollection.RawType
import GDAL.OGRGeometry.RawType
import GDAL.OGRPolygon.RawType
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGREnvelope.RawType
import GDAL.OGRPoint.RawType

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_getGeometryType"
               c_ogrgeometrycollection_getgeometrytype ::
               Ptr RawOGRGeometryCollection -> IO CUInt

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_getEnvelope"
               c_ogrgeometrycollection_getenvelope ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGREnvelope -> IO ()

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Intersects"
               c_ogrgeometrycollection_intersects ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Equals"
               c_ogrgeometrycollection_equals ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Disjoint"
               c_ogrgeometrycollection_disjoint ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Touches"
               c_ogrgeometrycollection_touches ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Crosses"
               c_ogrgeometrycollection_crosses ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Within"
               c_ogrgeometrycollection_within ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Contains"
               c_ogrgeometrycollection_contains ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Overlaps"
               c_ogrgeometrycollection_overlaps ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Boundary"
               c_ogrgeometrycollection_boundary ::
               Ptr RawOGRGeometryCollection -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Distance"
               c_ogrgeometrycollection_distance ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_ConvexHull"
               c_ogrgeometrycollection_convexhull ::
               Ptr RawOGRGeometryCollection -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Buffer"
               c_ogrgeometrycollection_buffer ::
               Ptr RawOGRGeometryCollection ->
                 CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Intersection"
               c_ogrgeometrycollection_intersection ::
               Ptr RawOGRGeometryCollection ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Union"
               c_ogrgeometrycollection_union ::
               Ptr RawOGRGeometryCollection ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_UnionCascaded"
               c_ogrgeometrycollection_unioncascaded ::
               Ptr RawOGRGeometryCollection -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Difference"
               c_ogrgeometrycollection_difference ::
               Ptr RawOGRGeometryCollection ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_SymDifference"
               c_ogrgeometrycollection_symdifference ::
               Ptr RawOGRGeometryCollection ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Centroid"
               c_ogrgeometrycollection_centroid ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRPoint -> IO CInt

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Simplify"
               c_ogrgeometrycollection_simplify ::
               Ptr RawOGRGeometryCollection -> CDouble -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_DelaunayTriangulation"
               c_ogrgeometrycollection_delaunaytriangulation ::
               Ptr RawOGRGeometryCollection ->
                 CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Polygonize"
               c_ogrgeometrycollection_polygonize ::
               Ptr RawOGRGeometryCollection -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_Distance3D"
               c_ogrgeometrycollection_distance3d ::
               Ptr RawOGRGeometryCollection -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_delete"
               c_ogrgeometrycollection_delete ::
               Ptr RawOGRGeometryCollection -> IO ()

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_oGRGeometryCollection_getNumGeometries"
               c_ogrgeometrycollection_ogrgeometrycollection_getnumgeometries ::
               Ptr RawOGRGeometryCollection -> IO CInt

foreign import ccall interruptible
               "HGDALOGRGeometryCollection.h OGRGeometryCollection_oGRGeometryCollection_getGeometryRef"
               c_ogrgeometrycollection_ogrgeometrycollection_getgeometryref ::
               Ptr RawOGRGeometryCollection -> CInt -> IO (Ptr RawOGRGeometry)
