{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.OGRLayer.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.OGRLayer.RawType
import GDAL.OGRLayer.FFI
import GDAL.OGRLayer.Interface
import GDAL.OGRLayer.Cast
import GDAL.OGRLayer.RawType
import GDAL.OGRLayer.Cast
import GDAL.OGRLayer.Interface
import GDAL.OGRFeature.RawType
import GDAL.OGRFeature.Cast
import GDAL.OGRFeature.Interface
import GDAL.OGRFeatureDefn.RawType
import GDAL.OGRFeatureDefn.Cast
import GDAL.OGRFeatureDefn.Interface
import GDAL.GDALMajorObject.RawType
import GDAL.GDALMajorObject.Cast
import GDAL.GDALMajorObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IOGRLayer (OGRLayer) where
        getFeature = xform1 c_ogrlayer_getfeature
        getFeatureCount = xform1 c_ogrlayer_getfeaturecount
        getLayerDefn = xform0 c_ogrlayer_getlayerdefn
        getNextFeature = xform0 c_ogrlayer_getnextfeature
        resetReading = xform0 c_ogrlayer_resetreading

instance () => IGDALMajorObject (OGRLayer) where

instance () => IDeletable (OGRLayer) where
        delete = xform0 c_ogrlayer_delete
