{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.OGRMultiSurface.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import GDAL.OGRMultiSurface.RawType
import GDAL.OGRMultiSurface.RawType
import GDAL.OGRGeometry.RawType
import GDAL.OGRPolygon.RawType
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGREnvelope.RawType
import GDAL.OGRPoint.RawType

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_getGeometryType"
               c_ogrmultisurface_getgeometrytype ::
               Ptr RawOGRMultiSurface -> IO CUInt

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_getEnvelope"
               c_ogrmultisurface_getenvelope ::
               Ptr RawOGRMultiSurface -> Ptr RawOGREnvelope -> IO ()

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Intersects"
               c_ogrmultisurface_intersects ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Equals"
               c_ogrmultisurface_equals ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Disjoint"
               c_ogrmultisurface_disjoint ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Touches"
               c_ogrmultisurface_touches ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Crosses"
               c_ogrmultisurface_crosses ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Within"
               c_ogrmultisurface_within ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Contains"
               c_ogrmultisurface_contains ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Overlaps"
               c_ogrmultisurface_overlaps ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Boundary"
               c_ogrmultisurface_boundary ::
               Ptr RawOGRMultiSurface -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Distance"
               c_ogrmultisurface_distance ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_ConvexHull"
               c_ogrmultisurface_convexhull ::
               Ptr RawOGRMultiSurface -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Buffer"
               c_ogrmultisurface_buffer ::
               Ptr RawOGRMultiSurface ->
                 CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Intersection"
               c_ogrmultisurface_intersection ::
               Ptr RawOGRMultiSurface ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Union"
               c_ogrmultisurface_union ::
               Ptr RawOGRMultiSurface ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_UnionCascaded"
               c_ogrmultisurface_unioncascaded ::
               Ptr RawOGRMultiSurface -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Difference"
               c_ogrmultisurface_difference ::
               Ptr RawOGRMultiSurface ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_SymDifference"
               c_ogrmultisurface_symdifference ::
               Ptr RawOGRMultiSurface ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Centroid"
               c_ogrmultisurface_centroid ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRPoint -> IO CInt

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Simplify"
               c_ogrmultisurface_simplify ::
               Ptr RawOGRMultiSurface -> CDouble -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_DelaunayTriangulation"
               c_ogrmultisurface_delaunaytriangulation ::
               Ptr RawOGRMultiSurface ->
                 CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Polygonize"
               c_ogrmultisurface_polygonize ::
               Ptr RawOGRMultiSurface -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_Distance3D"
               c_ogrmultisurface_distance3d ::
               Ptr RawOGRMultiSurface -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRMultiSurface.h OGRMultiSurface_delete"
               c_ogrmultisurface_delete :: Ptr RawOGRMultiSurface -> IO ()
